# Table of contents

- [Introduction](README.md)

## Getting Started

- [Project Setup](getting-started/project-setup.md)
  - [Using trunk](getting-started/project-setup/using-trunk.md)
  - [Using wasm-pack](getting-started/project-setup/using-wasm-pack.md)
  - [Using cargo-web](getting-started/project-setup/using-cargo-web.md)
- [Starter Templates](getting-started/starter-templates.md)
- [Build a Sample App](getting-started/build-a-sample-app.md)
- [Choose web-sys or stdweb](getting-started/choose-web-library.md)
- [Learn through examples](getting-started/examples.md)

## Core Concepts <a id="concepts"></a>

- [Using html!](concepts/html.md)
  - [Lists](concepts/html/lists.md)
  - [Elements](concepts/html/elements.md)
  - [Literals & Expressions](concepts/html/literals-and-expressions.md)
  - [Components](concepts/html/components.md)
- [Components](concepts/components.md)
  - [Properties](concepts/components/properties.md)
  - [Callbacks](concepts/components/callbacks.md)
  - [Refs](concepts/components/refs.md)
- [Agents](concepts/agents.md)
- [Services](concepts/services.md)
  - [Format](concepts/services/format.md)
- [Router](concepts/router.md)

## Advanced Topics

- [Optimizations & Best Practices](advanced-topics/optimizations.md)
- [Low-level library internals](advanced-topics/how-it-works.md)

## More

- [CSS](more/css.md)
- [Roadmap](more/roadmap.md)
- [Testing](more/testing.md)
- [Debugging](more/debugging.md)
- [External Libs](more/external-libs.md)
